# coding: utf-8

"""
    Panviva API Suite v3

    Wouldn't it be great if you could share information seamlessly? This connector allows you to push your knowledge further and consume a complete list of Panviva's API offerings.  **Content APIs** perform resource related operations , e.g. `document`, `folder`, `file`, `container`, `image`.  **Live APIs** enable real-time communications with online users on our client application.  **Artefact APIs** interact with curated Panviva content, created by the Digital Orchestrator.  # noqa: E501

    OpenAPI spec version: 1.0
    Contact: support@panviva.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six


class GetImageResponse(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'id': 'str',
        'name': 'str',
        'width': 'int',
        'height': 'int',
        'size': 'int',
        'content_type': 'str',
        'content': 'str'
    }

    attribute_map = {
        'id': 'id',
        'name': 'name',
        'width': 'width',
        'height': 'height',
        'size': 'size',
        'content_type': 'contentType',
        'content': 'content'
    }

    def __init__(self, id=None, name=None, width=None, height=None, size=None, content_type=None, content=None):  # noqa: E501
        """GetImageResponse - a model defined in Swagger"""  # noqa: E501

        self._id = None
        self._name = None
        self._width = None
        self._height = None
        self._size = None
        self._content_type = None
        self._content = None
        self.discriminator = None

        if id is not None:
            self.id = id
        if name is not None:
            self.name = name
        if width is not None:
            self.width = width
        if height is not None:
            self.height = height
        if size is not None:
            self.size = size
        if content_type is not None:
            self.content_type = content_type
        if content is not None:
            self.content = content

    @property
    def id(self):
        """Gets the id of this GetImageResponse.  # noqa: E501


        :return: The id of this GetImageResponse.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this GetImageResponse.


        :param id: The id of this GetImageResponse.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def name(self):
        """Gets the name of this GetImageResponse.  # noqa: E501


        :return: The name of this GetImageResponse.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this GetImageResponse.


        :param name: The name of this GetImageResponse.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def width(self):
        """Gets the width of this GetImageResponse.  # noqa: E501


        :return: The width of this GetImageResponse.  # noqa: E501
        :rtype: int
        """
        return self._width

    @width.setter
    def width(self, width):
        """Sets the width of this GetImageResponse.


        :param width: The width of this GetImageResponse.  # noqa: E501
        :type: int
        """

        self._width = width

    @property
    def height(self):
        """Gets the height of this GetImageResponse.  # noqa: E501


        :return: The height of this GetImageResponse.  # noqa: E501
        :rtype: int
        """
        return self._height

    @height.setter
    def height(self, height):
        """Sets the height of this GetImageResponse.


        :param height: The height of this GetImageResponse.  # noqa: E501
        :type: int
        """

        self._height = height

    @property
    def size(self):
        """Gets the size of this GetImageResponse.  # noqa: E501


        :return: The size of this GetImageResponse.  # noqa: E501
        :rtype: int
        """
        return self._size

    @size.setter
    def size(self, size):
        """Sets the size of this GetImageResponse.


        :param size: The size of this GetImageResponse.  # noqa: E501
        :type: int
        """

        self._size = size

    @property
    def content_type(self):
        """Gets the content_type of this GetImageResponse.  # noqa: E501


        :return: The content_type of this GetImageResponse.  # noqa: E501
        :rtype: str
        """
        return self._content_type

    @content_type.setter
    def content_type(self, content_type):
        """Sets the content_type of this GetImageResponse.


        :param content_type: The content_type of this GetImageResponse.  # noqa: E501
        :type: str
        """

        self._content_type = content_type

    @property
    def content(self):
        """Gets the content of this GetImageResponse.  # noqa: E501


        :return: The content of this GetImageResponse.  # noqa: E501
        :rtype: str
        """
        return self._content

    @content.setter
    def content(self, content):
        """Sets the content of this GetImageResponse.


        :param content: The content of this GetImageResponse.  # noqa: E501
        :type: str
        """

        self._content = content

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(GetImageResponse, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, GetImageResponse):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
