# coding: utf-8

"""
    Panviva API Suite v3

    Wouldn't it be great if you could share information seamlessly? This connector allows you to push your knowledge further and consume a complete list of Panviva's API offerings.  **Content APIs** perform resource related operations , e.g. `document`, `folder`, `file`, `container`, `image`.  **Live APIs** enable real-time communications with online users on our client application.  **Artefact APIs** interact with curated Panviva content, created by the Digital Orchestrator.  # noqa: E501

    OpenAPI spec version: 1.0
    Contact: support@panviva.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six


class GetSearchResponse(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'results': 'list[ResourceSearchResult]',
        'total': 'int',
        'links': 'list[Link]'
    }

    attribute_map = {
        'results': 'results',
        'total': 'total',
        'links': 'links'
    }

    def __init__(self, results=None, total=None, links=None):  # noqa: E501
        """GetSearchResponse - a model defined in Swagger"""  # noqa: E501

        self._results = None
        self._total = None
        self._links = None
        self.discriminator = None

        if results is not None:
            self.results = results
        if total is not None:
            self.total = total
        if links is not None:
            self.links = links

    @property
    def results(self):
        """Gets the results of this GetSearchResponse.  # noqa: E501


        :return: The results of this GetSearchResponse.  # noqa: E501
        :rtype: list[ResourceSearchResult]
        """
        return self._results

    @results.setter
    def results(self, results):
        """Sets the results of this GetSearchResponse.


        :param results: The results of this GetSearchResponse.  # noqa: E501
        :type: list[ResourceSearchResult]
        """

        self._results = results

    @property
    def total(self):
        """Gets the total of this GetSearchResponse.  # noqa: E501


        :return: The total of this GetSearchResponse.  # noqa: E501
        :rtype: int
        """
        return self._total

    @total.setter
    def total(self, total):
        """Sets the total of this GetSearchResponse.


        :param total: The total of this GetSearchResponse.  # noqa: E501
        :type: int
        """

        self._total = total

    @property
    def links(self):
        """Gets the links of this GetSearchResponse.  # noqa: E501


        :return: The links of this GetSearchResponse.  # noqa: E501
        :rtype: list[Link]
        """
        return self._links

    @links.setter
    def links(self, links):
        """Sets the links of this GetSearchResponse.


        :param links: The links of this GetSearchResponse.  # noqa: E501
        :type: list[Link]
        """

        self._links = links

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(GetSearchResponse, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, GetSearchResponse):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
