# coding: utf-8

"""
    Panviva API Suite v3

    Wouldn't it be great if you could share information seamlessly? This connector allows you to push your knowledge further and consume a complete list of Panviva's API offerings.  **Content APIs** perform resource related operations , e.g. `document`, `folder`, `file`, `container`, `image`.  **Live APIs** enable real-time communications with online users on our client application.  **Artefact APIs** interact with curated Panviva content, created by the Digital Orchestrator.  # noqa: E501

    OpenAPI spec version: 1.0
    Contact: support@panviva.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six


class ResourceSearchResult(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'type': 'str',
        'id': 'str',
        'name': 'str',
        'description': 'str',
        'matched_fields': 'list[str]',
        'snippet': 'str',
        'language': 'str',
        'links': 'list[Link]'
    }

    attribute_map = {
        'type': 'type',
        'id': 'id',
        'name': 'name',
        'description': 'description',
        'matched_fields': 'matchedFields',
        'snippet': 'snippet',
        'language': 'language',
        'links': 'links'
    }

    def __init__(self, type=None, id=None, name=None, description=None, matched_fields=None, snippet=None, language=None, links=None):  # noqa: E501
        """ResourceSearchResult - a model defined in Swagger"""  # noqa: E501

        self._type = None
        self._id = None
        self._name = None
        self._description = None
        self._matched_fields = None
        self._snippet = None
        self._language = None
        self._links = None
        self.discriminator = None

        if type is not None:
            self.type = type
        if id is not None:
            self.id = id
        if name is not None:
            self.name = name
        if description is not None:
            self.description = description
        if matched_fields is not None:
            self.matched_fields = matched_fields
        if snippet is not None:
            self.snippet = snippet
        if language is not None:
            self.language = language
        if links is not None:
            self.links = links

    @property
    def type(self):
        """Gets the type of this ResourceSearchResult.  # noqa: E501


        :return: The type of this ResourceSearchResult.  # noqa: E501
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this ResourceSearchResult.


        :param type: The type of this ResourceSearchResult.  # noqa: E501
        :type: str
        """

        self._type = type

    @property
    def id(self):
        """Gets the id of this ResourceSearchResult.  # noqa: E501


        :return: The id of this ResourceSearchResult.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this ResourceSearchResult.


        :param id: The id of this ResourceSearchResult.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def name(self):
        """Gets the name of this ResourceSearchResult.  # noqa: E501


        :return: The name of this ResourceSearchResult.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this ResourceSearchResult.


        :param name: The name of this ResourceSearchResult.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def description(self):
        """Gets the description of this ResourceSearchResult.  # noqa: E501


        :return: The description of this ResourceSearchResult.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this ResourceSearchResult.


        :param description: The description of this ResourceSearchResult.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def matched_fields(self):
        """Gets the matched_fields of this ResourceSearchResult.  # noqa: E501


        :return: The matched_fields of this ResourceSearchResult.  # noqa: E501
        :rtype: list[str]
        """
        return self._matched_fields

    @matched_fields.setter
    def matched_fields(self, matched_fields):
        """Sets the matched_fields of this ResourceSearchResult.


        :param matched_fields: The matched_fields of this ResourceSearchResult.  # noqa: E501
        :type: list[str]
        """

        self._matched_fields = matched_fields

    @property
    def snippet(self):
        """Gets the snippet of this ResourceSearchResult.  # noqa: E501


        :return: The snippet of this ResourceSearchResult.  # noqa: E501
        :rtype: str
        """
        return self._snippet

    @snippet.setter
    def snippet(self, snippet):
        """Sets the snippet of this ResourceSearchResult.


        :param snippet: The snippet of this ResourceSearchResult.  # noqa: E501
        :type: str
        """

        self._snippet = snippet

    @property
    def language(self):
        """Gets the language of this ResourceSearchResult.  # noqa: E501


        :return: The language of this ResourceSearchResult.  # noqa: E501
        :rtype: str
        """
        return self._language

    @language.setter
    def language(self, language):
        """Sets the language of this ResourceSearchResult.


        :param language: The language of this ResourceSearchResult.  # noqa: E501
        :type: str
        """

        self._language = language

    @property
    def links(self):
        """Gets the links of this ResourceSearchResult.  # noqa: E501


        :return: The links of this ResourceSearchResult.  # noqa: E501
        :rtype: list[Link]
        """
        return self._links

    @links.setter
    def links(self, links):
        """Sets the links of this ResourceSearchResult.


        :param links: The links of this ResourceSearchResult.  # noqa: E501
        :type: list[Link]
        """

        self._links = links

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ResourceSearchResult, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ResourceSearchResult):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
